; l𕶎ɕϊAZCu[  Version 1.00
; File:        stdlib.asm
; Target:      PIC18F14K50 48Mhz
; AZu:   Microchip MPASM(v5.51)
; :     PICKit 3
; [X:     2013/10/01 21:00

        #INCLUDE <p18f14k50.inc>

        EXTERN  DIV_MOD,DIV_A,DIV_B,Temp1,DIV_MODL,DIV_MODH,DIV_AL,DIV_AH
        EXTERN  ARGH,ARGL,ARG1,BYTE2HEX_TEMP
        GLOBAL  div8_8,div16_8
        GLOBAL  word2hex,word2deg,word2sdeg
     	GLOBAL	byte2hex,byte2bin,byte2deg
        GLOBAL  byte2bin,word2bin
        GLOBAL  hex2word

        CODE

;       Z    DIV_A / DIV_B  DIV_A   ]DIV_MODɕԂ
div8_8      ;   8bit/8bit=8bit
        clrf    DIV_MOD
        movlw   8
        movwf   Temp1
div8_8_loop
        bcf     STATUS,C            ;   L[tONA
        rlcf    DIV_A
        rlcf    DIV_MOD

        movf    DIV_B,W
        subwf   DIV_MOD   ;   f-W->f
        bnc     div8_8_non_sub     ;   Zʂ̏ꍇ
        bsf     DIV_A,0
        bra     div8_8_shift
div8_8_non_sub
        movf    DIV_B,W
        addwf   DIV_MOD            ;   Žʂ𑫂Ė߂
div8_8_shift
        decfsz  Temp1
        bra     div8_8_loop
        return

;       Z    DIV_AH:DIV_AL / DIV_B  DIV_AH:DIV_AL   ]DIV_MODL:DIV_MODLɕԂ
div16_8      ;   16bit/8bit=16bit
        clrf    DIV_MODL
        clrf    DIV_MODH
        movlw   d'16'
        movwf   Temp1
div16_8_loop
        bcf     STATUS,C
        rlcf    DIV_AL
        rlcf    DIV_AH
        rlcf    DIV_MODL
        rlcf    DIV_MODH

        movf    DIV_B,W
        subwf   DIV_MODL
        movlw   0
        subwfb  DIV_MODH
        bnc     div16_8_non_sub
        bsf     DIV_AL,0
        bra     div16_8_shift
div16_8_non_sub
        movf    DIV_B,W
        addwf   DIV_MODL
        movlw   0
        addwfc  DIV_MODH
div16_8_shift
        decfsz  Temp1
        bra     div16_8_loop
        return


word2sdeg   ; 2̕␔`word10iɕϊ
        movf    ARGH,W
        bn      word2sdeg_neg
        movlw   '+'
        movwf   POSTINC1
        rcall   word2deg
        return

word2sdeg_neg   ;   
;   word2̕␔`ŕ]
        comf    ARGH
        comf    ARGL
        incf    ARGL
        movlw   0
        addwfc  ARGH
        movlw   '-'
        movwf   POSTINC1
        rcall   word2deg
        return

word2deg    ;   2byte̐10iɕϊ
        movlw   d'4'
        addwf   FSR1L
        movlw   0
        addwfc  FSR1H

        movf    ARGL,W
        movwf   DIV_AL
        movf    ARGH,W
        movwf   DIV_AH
        movlw   d'10'
        movwf   DIV_B

        rcall   div16_8
        movf    DIV_MODL,W
        addlw   '0'
        movwf   POSTDEC1
        rcall   div16_8
        movf    DIV_MODL,W
        addlw   '0'
        movwf   POSTDEC1
        rcall   div16_8
        movf    DIV_MODL,W
        addlw   '0'
        movwf   POSTDEC1
        rcall   div16_8
        movf    DIV_MODL,W
        addlw   '0'
        movwf   POSTDEC1
        movf    DIV_AL,W
        addlw   '0'
        movwf   POSTDEC1

        return

byte2deg    ;   1bye̐10iɕϊ
        movf    ARG1,W

        movwf   POSTINC1
        movwf   POSTINC1

        movwf   DIV_A
        movlw   d'10'
        movwf   DIV_B
        call    div8_8
        movf    DIV_MOD,W
        movwf   POSTDEC1
        call    div8_8
        movf    DIV_MOD,W

        movwf   POSTDEC1
        movf    DIV_A,W
        movwf   INDF1
        movlw   '0'
        addwf   POSTINC1
        addwf   POSTINC1
        addwf   POSTINC1
        return

word2hex          ;  2byte16iϊ
        movf    ARGH,W
        movwf   ARG1
        rcall   byte2hex

        movf    ARGL,W
        movwf   ARG1
        rcall   byte2hex

        return

byte2hex           ;  1byte16iϊ
        movlw   d'10'
        movwf   BYTE2HEX_TEMP
        iorwf   POSTINC1

        movf    ARG1,W   ;   
        andlw   0fh
        movwf   POSTDEC1

        swapf   ARG1,W   ;   
        andlw   0fh
        movwf   POSTINC1

        movf    INDF1,W     ;   
        cpfsgt  BYTE2HEX_TEMP
        addlw   d'7'
        addlw   '0'
        movwf   POSTDEC1

        movf    INDF1,W     ;   
        cpfsgt  BYTE2HEX_TEMP
        addlw   d'7'
        addlw   '0'
        movwf   INDF1

        movf    POSTINC1,F
        movf    POSTINC1,F
        return

byte2bin           ;  1byte2iϊ
        movlw   8
        movwf   Temp1
byte2bin_loop
        movlw   '0'
        btfss   ARG1,7
        goto    byte2bin_loop2
        addlw   1
byte2bin_loop2
        movwf   POSTINC1
        rlncf   ARG1
        decfsz  Temp1
        goto    byte2bin_loop
        return

word2bin
        movff   ARGH,ARG1
        rcall   byte2bin
        movff   ARGL,ARG1
        rcall   byte2bin
        return


hex2word    ; 16iwordlɕϊ FSR1:AhX
        clrf    ARGL
        clrf    ARGH

        movlw   d'9'
        movwf   Temp1

hex2word_l2
        movlw   029h ; 0̕R[h̏ꍇI
        cpfsgt  INDF1 ; F>WREĜƂXLbv
        bra     hex2word_l1
        movf    INDF1,W
        bz      hex2word_l1

        ; 4bitVtg

        rlcf    ARGL,F
        rlcf    ARGH,F
        rlcf    ARGL,F
        rlcf    ARGH,F
        rlcf    ARGL,F
        rlcf    ARGH,F
        rlcf    ARGL,F
        rlcf    ARGH,F
        movf    ARGL,W
        andlw   0f0h
        movwf   ARGL

        movf    INDF1,W
        movff   POSTINC1,ARG1
        movlw   '0'
        subwf   ARG1,W

        cpfslt  Temp1 ; WREG>F(9) ̂ƂXLbv
        bra     hex2word_l3
        movwf   ARG1
        movlw   'a'-'0'-d'10'
        subwf   ARG1,W
hex2word_l3

        iorwf   ARGL,F
        bra     hex2word_l2
hex2word_l1
        return

        END